//+------------------------------------------------------------------+
//|                                                Parser_Tester.mqh |
//|                                            Copyright 2010, Urain |
//|                            https://login.mql5.com/ru/users/Urain |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, Urain"
#property link      "https://login.mql5.com/ru/users/Urain"
//+------------------------------------------------------------------+
//| call of the file                                                 |
//| #include <Parser_Tester.mqh>                                     |
//+------------------------------------------------------------------+
#include "Decode_MarketWatch.mqh"
#include "HTML.mqh"
#include "Table.mqh"
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class SparamGlob
  {
public:
                     SparamGlob(){};
                    ~SparamGlob(){};
   string            fond_comments;
   int               font_sizes;
   color             colorBuy;
   color             colorSell;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CHistoryObject
  {

public:
                     CHistoryObject(void){};
                    ~CHistoryObject(void){};
   SparamGlob        g;
   void              TextVol(long chart_id,string name,color COLOR,string text,datetime time,double price);
   void              TrendLine(long chart_id,string name,color COLOR,datetime time0,datetime time1,double price0,double price1);
   void              TrendVLine(long chart_id,string name,color COLOR,datetime time0,double price0,double price1);
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CHistoryObject::TextVol(long chart_id,string name,color COLOR,string text,datetime time,double price)
  {
   if(ObjectFind(chart_id,name)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name,OBJ_TEXT,0,0,0))
        {//---    
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name+". Error code ",GetLastError());
         ResetLastError();
         return;
        }
     }
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,COLOR);
   ObjectSetString(chart_id,name,OBJPROP_FONT,g.fond_comments);
   ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
//---
   ObjectSetInteger(chart_id,name,OBJPROP_TIME,time);
//---
   ObjectSetDouble(chart_id,name,OBJPROP_PRICE,price);
   if(text=="out")
     {
      if(COLOR==clrRed){ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_UPPER);}
      else {ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_LOWER);}
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,(g.font_sizes*2+1)/2);
     }
   else
     {
      if(COLOR==clrRed){ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_LEFT_LOWER);}
      else {ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);}
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,g.font_sizes*2/2);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CHistoryObject::TrendLine(long chart_id,string name,color COLOR,datetime time0,datetime time1,double price0,double price1)
  {
   if(ObjectFind(chart_id,name)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name,OBJ_TREND,0,0,0,0,0))
        {//--- 
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name+". Error code ",GetLastError());
         ResetLastError();
        }
     }
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,COLOR);
   ObjectSetInteger(chart_id,name,OBJPROP_WIDTH,1);
//---
   ObjectSetInteger(chart_id,name,OBJPROP_TIME,0,time0);
   ObjectSetInteger(chart_id,name,OBJPROP_TIME,1,time1);
//---
   ObjectSetDouble(chart_id,name,OBJPROP_PRICE,0,price0);
   ObjectSetDouble(chart_id,name,OBJPROP_PRICE,1,price1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CHistoryObject::TrendVLine(long chart_id,string name,color COLOR,datetime time0,double price0,double price1)
  {
   if(ObjectFind(chart_id,name)<0)// if there is no object yet
     {//--- try to create the object         
      if(ObjectCreate(chart_id,name,OBJ_TREND,0,0,0,0,0))
        {//---        
         ObjectSetInteger(chart_id,name,OBJPROP_COLOR,COLOR);
         ObjectSetInteger(chart_id,name,OBJPROP_WIDTH,1);
         //---
         ObjectSetInteger(chart_id,name,OBJPROP_TIME,0,time0);
         ObjectSetInteger(chart_id,name,OBJPROP_TIME,1,time0);
         //---
         ObjectSetDouble(chart_id,name,OBJPROP_PRICE,0,price0);
         ObjectSetDouble(chart_id,name,OBJPROP_PRICE,1,price1);
        }
      else
        {//--- failed to create the object, tell about it
         Print("Failed to create the object "+name+". Error code ",GetLastError());
         ResetLastError();
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CHistoryObject sp;
CTable table[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CParser_Tester
  {
   ENUM_DATATYPE     TYPE_[13];
   int               total_column;
   int               total_line;
   CTable           *table0;
   CTable           *table1[];
   CTable           *table;
   string            folders;
   string            folder;
   string            folder_plus;
   bool              flag_break;
   string            ZeroString(string vol);
   void              KnowTypePos(int j,int beg,int end,string vol_pos);
   bool              flag_starts;
public:
   long              chart_id;
   string            trade_symbol[];
   int               trade_symbol_total;
   datetime          begtime;
   datetime          endtime;
   CDecodeMarketWatch dec;
                     CParser_Tester(void);
                    ~CParser_Tester(void)
     {
      delete table0;
      int total=ArraySize(table1);
      for(int i=0;i<total;i++)delete table1[i];
     };
   void              ParserOnStart(string folder_);
   void              ParserOnProcess();
   string            WriteRead();
   void              WriteWrite(CTable *table_,string folder_="test ",bool flag_all=false);
   int               Parser(string text_);
   void              HistoryDrawOnProcess(CTable *table_,long chart_id_);
   void              HistoryDraw(CTable *table_);
   void              HistoryPos(CTable *table_);
   void              ProcessingTable();
   void              ManipulationTable_0(CTable *table_);
   void              ManipulationTable_1(CTable *table_,string sym);
/*
   declared on the global scope, used in Player5_1.mqh 
   void              TextVol(long chart_id,string name,color COLOR,int font_size,string text,datetime time,double price);
   void              TrendLine(long chart_id,string name,color COLOR,datetime time0,datetime time1,double price0,double price1);
   void              TrendVLine(long chart_id,string name,color COLOR,datetime time0,double price0,double price1);
   */
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::CParser_Tester(void)
  {
//Print(__FUNCTION__);
   begtime=0;
   endtime=0;
   dec.Inits();
   trade_symbol_total=0;
   total_column=13;
   total_line=0;
   flag_break=false;
   TYPE_[0]=TYPE_DATETIME;// Time  ENUM_DATATYPE     
   TYPE_[1]=TYPE_LONG;    // Deal
   TYPE_[2]=TYPE_STRING;  // Symbol   
   TYPE_[3]=TYPE_STRING;  // Type
   TYPE_[4]=TYPE_STRING;  // Direction
   TYPE_[5]=TYPE_DOUBLE;  // Volume
   TYPE_[6]=TYPE_DOUBLE;  // Price
   TYPE_[7]=TYPE_LONG;    // Order
   TYPE_[8]=TYPE_DOUBLE;  // Commission
   TYPE_[9]=TYPE_DOUBLE;  // Swap
   TYPE_[10]=TYPE_DOUBLE; // Profit
   TYPE_[11]=TYPE_DOUBLE; // Balance
   TYPE_[12]=TYPE_STRING; // Comment
   table0=new CTable();
   flag_starts=true;// flag of the zero start for backup of the table 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::ParserOnStart(string folder_)
  {
//---    
   folder=folder_;
   table0.FirstResize(TYPE_);             // table layout, determination of types of columns 
   WriteRead();

   ParserOnProcess();

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::ParserOnProcess()
  {
//---
   ProcessingTable();// make the first pass, get the array of symbols

   int total=ArraySize(trade_symbol);
   for(int i=0;i<total;i++)// get history for each traded symbol
     {
      Comment("OnInit   Parsing trade history of "+trade_symbol[i]);
      ProcessingTable();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::HistoryDrawOnProcess(CTable *table_,long chart_id_)
  {
   chart_id=chart_id_;
//---   
   for(int i=0;i<trade_symbol_total;i++)
     {
      if(ChartSymbol(chart_id_)==trade_symbol[i])
        {
         table_.CopyTable(GetPointer(table1[i]));// copy the table to pass to the player
         HistoryDraw(table1[i]);// draw the history on the specified chart
        }
     }

   ENUM_DATATYPE TYPEs[]; // create a table to store the balances of all symbols  
   ArrayResize(TYPEs,trade_symbol_total+1);
   TYPEs[0]=TYPE_DATETIME;
   for(int i=0;i<trade_symbol_total;i++)TYPEs[i+1]=TYPE_DOUBLE;
   CTable *tableAll_Balance=new CTable(); tableAll_Balance.FirstResize(TYPEs);// initialization   
   for(int i=0;i<trade_symbol_total;i++)tableAll_Balance.StringDigits(i+1,2); // set accuracy 

   tableAll_Balance.SecondResize(tableAll_Balance.SecondSize()+2);
   tableAll_Balance.Set(0,0,begtime);
   tableAll_Balance.Set(0,1,endtime);
   tableAll_Balance.SortTwoDimArray(0,0,tableAll_Balance.SecondSize()-1,true);
   for(int i=0;i<trade_symbol_total;i++)
     {
      int size=table1[i].SecondSize();
      for(int j=0;j<size;j++)
        {
         datetime temp; table1[i].Get(0,j,temp);
         int ind=tableAll_Balance.QuickSearch(0,temp,0,tableAll_Balance.SecondSize()-1,true);
         if(ind==-1)
           {
            tableAll_Balance.SecondResize(tableAll_Balance.SecondSize()+1);
            tableAll_Balance.Set(0,tableAll_Balance.SecondSize()-1,temp);
            tableAll_Balance.SortTwoDimArray(0,0,tableAll_Balance.SecondSize()-1,true);
           }
        }
     }
   int size=tableAll_Balance.SecondSize();
   for(int i=0;i<trade_symbol_total;i++)
     {
      tableAll_Balance.Set(i+1,0,0.);
      for(int j=1;j<size;j++)
        {
         int tab_end=table1[i].SecondSize()-1;
         datetime temp; tableAll_Balance.Get(0,j,temp);
         int ind=table1[i].QuickSearch(0,temp,0,tab_end,true);

         if(ind==-1)
            tableAll_Balance.Set(i+1,j,tableAll_Balance.sGet(i+1,j-1));
         else
            tableAll_Balance.Set(i+1,j,table1[i].sGet(6,ind));
        }
     }
   WriteWrite(GetPointer(tableAll_Balance),"All balance ",true);
   delete tableAll_Balance;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string CParser_Tester::WriteRead()
  {
   string text="";
   int han=FileOpen(folder+".html",FILE_READ|FILE_SHARE_READ|FILE_ANSI,"\n");
   if(han!=INVALID_HANDLE)
     {
      while(!IsStopped())
        {
         string temp=FileReadString(han);
         StringTrimLeft(temp);StringTrimRight(temp);
         text=text+temp+"\n";
         if(FileTell(han)>=FileSize(han))break;
        }
      FileClose(han);
      Parser(text);
     }
   else {Print("File open failed "+folder+".html, error",GetLastError()); ExpertRemove();}
   return(text);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::WriteWrite(CTable *table_,string folder_="test ",bool flag_all=false)
  {
   table=table_;
   string folders=folder+" "+folder_;
   int han=FileOpen(folders+".csv",FILE_WRITE|FILE_SHARE_WRITE|FILE_CSV|FILE_ANSI,";");
   if(han!=INVALID_HANDLE)
     {
      total_line=table.SecondSize();
      total_column=table.FirstSize();
      if(flag_all)
        {
         string text="time";
         for(int i=1;i<total_column;i++)
            text=text+";"+trade_symbol[i-1];
         FileWrite(han,text);   
        }
      for(int j=0;j<total_line;j++)
        {
         string text=table.sGet(0,j);
         for(int i=1;i<total_column;i++)
            text=text+";"+table.sGet(i,j);
         FileWrite(han,text);
        }
      FileClose(han);
     }
   else Print("File open failed "+folders+".csv, error",GetLastError());
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CParser_Tester::Parser(string text_)
  {
   string text=text_;
   CHTML h;
   int table_pos=0,tr_pos=0,th_pos=0,div_pos=0,td_pos=0,b_pos=0;
   string table_text,div_text,tr_text,th_text,td_text,b_text;
   h.body.Search(text,0,false,true);
   text=h.body.base.casket;

   table_pos=0;int prev_table_pos; int ff=0; bool flag_deal=false;
   while(!IsStopped())// just in case, I doubt there will be a file with a hundred tables
     {
      prev_table_pos=table_pos;// save the previous value
      //--- searching for the necessary sub-table       
      table_pos=h.table.Search(text,table_pos,true,true); if(table_pos==-1)break;// in case the tag is not found, exit from searching of a table
      table_text=h.table.base.casket;

      th_pos=0; int fd=0;
      while(!IsStopped())// just in case, I doubt there will be a file with 10000 headers
        {
         //--- searching for a header         
         th_pos=h.th.Search(table_text,th_pos,true,true);   if(th_pos==-1)break;// if the tab is not found, exit from searching of a header
         th_text=h.th.base.casket;

         //--- parsing a header 
         div_pos=h.div.Search(th_text,0,true);
         div_text=h.div.base.casket;

         b_pos=h.b_.Search(div_text,0,true,true);
         b_text=h.b_.base.casket;
         if(b_text=="" || b_text=="Deals"){prev_table_pos=table_pos; flag_deal=true; break;}//if the required header is not found, exit from both cycles
         fd++; if(fd>10000){ExpertRemove(); break;}
        }
      if(flag_deal)break;
      ff++; if(ff>100){ExpertRemove(); break;}
     }

   tr_pos=th_pos;
   tr_pos=h.tr.Search(table_text,tr_pos,true,true);
   tr_pos=h.tr.Search(table_text,tr_pos,true,true);

//---  -
   table0.StringDigits(5,2);            // set accuracy 
   table0.StringDigits(6,5);            // set accuracy
   table0.StringDigits(8,2);            // set accuracy 
   table0.StringDigits(9,2);            // set accuracy 
   table0.StringDigits(10,2);           // set accuracy 
   table0.StringDigits(11,2);           // set accuracy

   int j=0; double balans=0;
   while(!IsStopped())
     {
      h.tr.base.casket="";
      tr_pos=h.tr.Search(table_text,tr_pos,true,true);
      tr_text=h.tr.base.casket;

      //---
      h.td.Search(tr_text,0,true,true);
      string td_header=h.td.base.header;
      if(td_header>" nowrap")break;
      //---      

      td_pos=1;
      table0.SecondResize(j+1);                     // changing the number of lines  
      for(int i=0;i<total_column;i++)
        {
         td_pos=h.td.Search(tr_text,td_pos-1,true,true);
         if(i==11)
           {
            table0.Set(i,j,h.td.base.casket);       // assigning of data to the table
            if(j==0)
              {
               table0.Get(11,0,balans); table0.Set(11,0,0.);
              }
            else
              {
               double temp;table0.Get(11,j,temp);
               temp-=balans;
               table0.Set(11,j,temp);
              }
           }
         else
           {
            table0.Set(i,j,h.td.base.casket);       // assigning of data to the table
           }
        }
      j++;
     }
   if(begtime!=0)
     {
      datetime temp; table0.Get(0,0,temp); begtime=fmin(temp,begtime);
     }
   else table0.Get(0,0,begtime);  // save the time of start of trading 

   if(endtime!=0)
     {
      datetime temp; table0.Get(0,j-1,temp); begtime=fmax(temp,endtime);
     }
   else table0.Get(0,j-1,endtime);// save the time of end of trading   
//---
   return(j);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::ProcessingTable()
  {
//Print(__FUNCTION__);
   if(flag_starts)// make a copy during the first pass
     {
      ManipulationTable_0(GetPointer(table0));
     }
   else
     {
      int size=ArraySize(table1);
      ArrayResize(table1,size+1);table1[size]=new CTable();
      table1[size].CopyTable(GetPointer(table0));// restore for the copy during next
      ManipulationTable_1(GetPointer(table1[size]),trade_symbol[size]);
      HistoryPos(GetPointer(table1[size]));
      WriteWrite(GetPointer(table1[size]),trade_symbol[size]);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::ManipulationTable_0(CTable *table_)
  {
   table=table_;
   table.SortTwoDimArray(2,0,table.SecondSize()-1,true);// sorting by symbol
   flag_starts=false;

   for(int i=0;i<dec.symbol_total;i++)
     {
      int ind=table.QuickSearch(2,dec.symbol[i],0,table.SecondSize()-1,true);
      if(ind!=-1)
        {
         trade_symbol_total++;
         ArrayResize(trade_symbol,trade_symbol_total);
         trade_symbol[trade_symbol_total-1]=dec.symbol[i];
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::ManipulationTable_1(CTable *table_,string sym)
  {
   table=table_;
   folder_plus=sym;//ChartSymbol(chart_id);
   flag_break=true;
   int end=table.SecondSize()-1,beg=table.SearchFirst(2,folder_plus,0,end,true);// search for the start
                                                                                // Print(__FUNCTION__+":"+folder_plus+"["+beg+"]");
   if(beg>-1)
     {
      end=table.SearchLast(2,folder_plus,beg,end,true);// search for the end
      table.SortTwoDimArray(1,beg,end,true);// sort the selection by deal number 
      flag_break=false;
      total_line=end+1-beg;
     }
   else
     {flag_break=true; total_line=0;}// if it is not found, set the flag
//Print(__FUNCTION__+"  beg["+beg+"]  end["+end+"]");
   if(flag_break)return;
//--- moving the column, cutting the number of columns
// Time Deal Symbol Type Direction Volume Price Order Commission Swap Profit Balance Comment
//   0      1     2     3       4        5    6     7      8       9    10      11       12

//table.SortTwoDimArray(1,beg,end,true);// sort the selection by deal number 
   table.Insert(12,9);  //   0 1 2 3 4 5 6 7 8 10 11 12 9
   table.Insert(12,8);  //   0 1 2 3 4 5 6 7 10 11 12 9 8
   table.Insert(12,7);  //   0 1 2 3 4 5 6 10 11 12 9 8 7
   table.Insert(0,2);   //   2 0 1 3 4 5 6 10 11 12 9 8 7
   table.Insert(12,2);  //   2 0 3 4 5 6 10 11 12 9 8 7 1
   table.Insert(12,0);  //   0 3 4 5 6 10 11 12 9 8 7 1 2
   table.Insert(7,10);  //   0 3 4 5 6 10 11 7 12 9 8 1 2
   table.Insert(8,11);  //   0 3 4 5 6 10 11 7 1 12 9 8 2
   table.Insert(9,11);  //   0 3 4 5 6 10 11 7 9 1 12 8 2
   table.Insert(10,11); //   0 3 4 5 6 10 11 7 9 1 8 12 2

   table.PruningTable(11);
//--- ordering the table    
   CTable *temp=new CTable();
   temp.CopyTable(GetPointer(table),beg,end);
   table.CopyTable(GetPointer(temp));
   delete temp;
//--- calculation of positions
   int Totaltable=table.SecondSize();
   long c=1,n=0; table.Set(7,0,c); table.Set(8,0,n); n++;
   for(int j=1;j<Totaltable;j++)
     {
      string direction=table.sGet(2,j-1);
      string direction_next=table.sGet(2,j);
      if(direction=="out" && direction_next=="in")
        {
         table.Set(7,j-1,c); c++; table.Set(7,j,c);
         n=0; table.Set(8,j,n); n++;
        }
      else {table.Set(7,j,c); table.Set(8,j,n); n++;}
      if(j==1 && direction_next=="out"){table.Set(8,j,1);}

      double temp_money,temp_balance;
      table.Get(5,j,temp_money);
      table.Get(6,j-1,temp_balance);
      table.Set(6,j,temp_money+temp_balance);
     }
   string direction=table.sGet(2,Totaltable-1);
   if(direction=="out")table.Set(7,Totaltable-1,c);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// time, type, direction, volume, price, deal result, balance, positionNo, No of deal in position, position direction
//   0     1      2        3      4        5         6        7           8                  9
void CParser_Tester::HistoryDraw(CTable *table_)
  {
//Print("ID hdr",chart_id);
   table=table_;
   int digits_vol=1;
   int total=table.SecondSize();
   long Pos=0;
   table.Get(7,total-1,Pos);
   for(int i=1;i<=Pos;i++)
     {
      int beg=table.SearchFirst(7,i,0,total-1,true);// find open positions
      int end=table.SearchLast(7,i,0,total-1,true);// find closed positions

      bool Color=false; color COLOR;
      if(table.sGet(1,beg)=="sell")Color=true;

      if(Color)COLOR=sp.g.colorSell;
      else COLOR=sp.g.colorBuy;
      double price_pos; table.Get(4,beg,price_pos);// get the initial value of position
      double vol_pos;  table.Get(3,beg,vol_pos);// get the initial volume of position

      bool pos_type; double vol_deal=vol_pos;
      datetime time_open,time_close;
      double   price_open,price_close;

      table.Get(0,beg,time_open);
      table.Get(4,beg,price_open);
      table.Get(0,beg+1,time_close);
      table.Get(4,beg+1,price_close);
      string text="["+DoubleToString(vol_deal,digits_vol)+"|"+DoubleToString(vol_deal,digits_vol)+"]";
      sp.TextVol(chart_id,"Text ["+(string)i+"][0]",COLOR,text,time_open,price_pos);
      sp.TrendVLine(chart_id,"TrLineV ["+(string)i+"][0]",COLOR,time_open,price_pos,price_open);
      sp.TrendLine(chart_id,"TrLine ["+(string)i+"][0]",COLOR,time_open,time_close,price_pos,price_close);
      if(beg+1==end)
        {
         text="out";
         sp.TextVol(chart_id,"Text out ["+(string)i+"][0]",COLOR,text,time_close,price_close);         
         continue;
        }

      for(int j=beg+1;j<end;j++)
        {
         bool flag_vol_color=false;

         table.Get(3,j,vol_deal);
         table.Get(0,j,time_open);
         table.Get(4,j,price_open);
         table.Get(0,j+1,time_close);
         table.Get(4,j+1,price_close);
         if(table.sGet(2,j)=="in/out")
           {
            vol_pos=NormalizeDouble(vol_deal-vol_pos,digits_vol);
            if(table.sGet(1,j)=="sell")Color=true;
            else Color=false;
            price_pos=price_open;

           }
         else
           {
            if(table.sGet(1,j)=="sell")pos_type=true;
            else pos_type=false;
            if(pos_type==Color)// average
              {
               double  tempR=(price_open-price_pos)/2.;
               double  tempD=fmin(vol_deal,vol_pos)/fmax(vol_deal,vol_pos);
               if(vol_deal<vol_pos) price_pos=  price_pos  + tempR*tempD;
               else                 price_pos=  price_open - tempR*tempD;
               vol_pos=NormalizeDouble(vol_pos+vol_deal,digits_vol);
              }
            else
              {
               // price_pos - don't change
               vol_pos=NormalizeDouble(vol_pos-vol_deal,digits_vol);
               flag_vol_color=true;
              }
           }
         if(Color)COLOR=sp.g.colorSell;
         else COLOR=sp.g.colorBuy;

         string vol_deal_str=DoubleToString(vol_deal,digits_vol);
         string vol_pos_str=DoubleToString(vol_pos,digits_vol);
         if(flag_vol_color)vol_deal_str="<"+vol_deal_str+">";

         text="["+vol_deal_str+"|"+vol_pos_str+"]";
         sp.TextVol(chart_id,"Text ["+(string)i+"]["+table.sGet(8,j)+"]",COLOR,text,time_open,price_pos);

         sp.TrendVLine(chart_id,"TrLineV ["+(string)i+"]["+table.sGet(8,j)+"]",COLOR,time_open,price_pos,price_open);
         sp.TrendLine(chart_id,"TrLine ["+(string)i+"]["+table.sGet(8,j)+"]",COLOR,time_open,time_close,price_pos,price_close);
         if(j==end-1)
           {
            text="out";
            sp.TextVol(chart_id,"Text out ["+(string)i+"]["+table.sGet(8,j)+"]",COLOR,text,time_close,price_close);
           }         
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
// time, type, direction, volume, price, deal result, balance, positionNo, No of deal in position, position direction
//   0     1      2        3      4        5         6        7           8                  9
void CParser_Tester::HistoryPos(CTable *table_)
  {

   table=table_;

   int digits_vol=1;
   int total=table.SecondSize();
   long Pos=0;
   table.Get(7,total-1,Pos);
   for(int i=1;i<=Pos;i++)
     {
      int beg=table.SearchFirst(7,i,0,total-1,true);// find open positions
      int end=table.SearchLast(7,i,0,total-1,true);// find closed positions
      bool Color=false; color COLOR;
      if(table.sGet(1,beg)=="sell")Color=true;

      if(Color)COLOR=sp.g.colorSell;
      else COLOR=sp.g.colorBuy;
      double price_pos; table.Get(4,beg,price_pos);// get the initial value of position
      double vol_pos;  table.Get(3,beg,vol_pos);// get the initial volume of position

      bool pos_type; double vol_deal=vol_pos;
      datetime time_open,time_close;
      double   price_open,price_close;

      table.Get(0,beg,time_open);
      table.Get(4,beg,price_open);
      table.Get(0,beg+1,time_close);
      table.Get(4,beg+1,price_close);

      if(beg+1==end)
        {
         KnowTypePos(-1,beg,end,"");
         KnowTypePos(-2,beg,end,"");
         continue;
        }

      for(int j=beg+1;j<end;j++)
        {
         bool flag_vol_color=false;

         table.Get(3,j,vol_deal);
         table.Get(0,j,time_open);
         table.Get(4,j,price_open);
         table.Get(0,j+1,time_close);
         table.Get(4,j+1,price_close);
         if(table.sGet(2,j)=="in/out")
           {
            vol_pos=NormalizeDouble(vol_deal-vol_pos,digits_vol);
            if(table.sGet(1,j)=="sell")Color=true;
            else Color=false;
            price_pos=price_open;

           }
         else
           {
            if(table.sGet(1,j)=="sell")pos_type=true;
            else pos_type=false;
            if(pos_type==Color)// average
              {
               double  tempR=(price_open-price_pos)/2.;
               double  tempD=fmin(vol_deal,vol_pos)/fmax(vol_deal,vol_pos);
               if(vol_deal<vol_pos) price_pos=  price_pos  + tempR*tempD;
               else                 price_pos=  price_open - tempR*tempD;
               vol_pos=NormalizeDouble(vol_pos+vol_deal,digits_vol);
              }
            else
              {
               // price_pos - don't change
               vol_pos=NormalizeDouble(vol_pos-vol_deal,digits_vol);
               flag_vol_color=true;
              }
           }
         if(Color)COLOR=sp.g.colorSell;
         else COLOR=sp.g.colorBuy;

         string vol_pos_str=DoubleToString(vol_pos,digits_vol);
         KnowTypePos(j,beg,end,vol_pos_str);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CParser_Tester::KnowTypePos(int j,int beg,int end,string vol_pos)
  {
   if(j==beg+1 || j==-1)
     {
      if(table.sGet(1,beg)=="sell")table.Set(9,beg,"1");
      else table.Set(9,beg,"0");
      table.Set(10,beg,table.sGet(3,beg));
     }
//---
   if(j>-1)
     {
      if(table.sGet(2,j)=="in/out")
        {
         if(table.sGet(1,j)=="sell")table.Set(9,j,"1");
         else table.Set(9,j,"0");
        }
      if(table.sGet(2,j)=="out" || table.sGet(2,j)=="in")
        {
         table.Set(9,j,table.sGet(9,j-1));
        }
      table.Set(10,j,vol_pos);
     }
//---
   if(j==end-1 || j==-2)
     {
      table.Set(9,end,"-1");// assign -1 to the last deal in position
      table.Set(10,end,"0.0");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string CParser_Tester::ZeroString(string vol)
  {
   int len=StringLen(vol);
   string res="";
   for(int c=0;c<len;c++)res=res+" ";
   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
